#ifndef MRUBYCONF_H
#define MRUBYCONF_H

#include <stdint.h>
typedef double mrb_float;
typedef int32_t mrb_int;
typedef int32_t mrb_sym;

#define readint(p,base) strtol((p),NULL,(base))
#define readfloat(p) strtod((p),NULL)

#undef  INCLUDE_REGEXP  /* undef  means "This Ruby don't include Regexp,MatchData,Encoding_Class" */
//#define INCLUDE_REGEXP  /* define means "This Ruby       include Regexp,MatchData,Encoding_Class" */

#undef  HAVE_UNISTD_H /* WINDOWS */
#define HAVE_UNISTD_H /* LINUX */
#define HAVE_STRING_H /* CYGWIN */ // added by yamashita

#define SIZEOF_INT              4
#define SIZEOF_SHORT            2
#define SIZEOF_LONG             4
#define SIZEOF_LONG_LONG        8
#define SIZEOF___INT64          0
#define SIZEOF_VOIDP            4
#define SIZEOF_FLOAT            4
#define SIZEOF_DOUBLE           8

#ifndef FALSE
# define FALSE 0
#endif

#ifndef TRUE
# define TRUE 1
#endif

/* reduce heap size ---> */
//#define MRB_SMALL_HEAP_PAGE
#define MRB_VERY_SMALL_HEAP_PAGE
#define SYMPLE_ERROR_CLASS
#define MRB_REMOVE_VERSION
#define MRB_SMALL_ARENA
#define MRB_VALUE_PACK
#define MRB_SLIM_RHASH
#define MRB_SLIM_KHASH
/* <--- reduce heap size */

//#define PC_SIMULATION //deleted by yamashita
#define HEAP_PROFILE    //added by yamashita

#endif	/* MRUBYCONF_H */
